Index: /palm/trunk/SOURCE/microphysics.f90
===================================================================
--- /palm/trunk/SOURCE/microphysics.f90	(revision 1360)
+++ /palm/trunk/SOURCE/microphysics.f90	(revision 1361)
@@ -745,96 +577,118 @@
        REAL(wp)     ::  xr                !:
 
-       DO  k = nzb_s_inner(j,i)+1, nzt
-          IF ( qr_1d(k) > eps_sb )  THEN
-!
-!--          Actual liquid water temperature:
-             t_l = t_d_pt(k) * pt_1d(k)
-!
-!--          Saturation vapor pressure at t_l:
-             e_s = 610.78_wp * EXP( 17.269_wp * ( t_l - 273.16_wp ) / ( t_l - 35.86_wp ) )
-!
-!--          Computation of saturation humidity:
-             q_s = 0.622_wp * e_s / ( hyp(k) - 0.378_wp * e_s )
-             alpha = 0.622_wp * l_d_r * l_d_cp / ( t_l * t_l )
-             q_s = q_s * ( 1.0_wp + alpha * q_1d(k) ) / ( 1.0_wp + alpha * q_s )
-!
-!--          Supersaturation:
-             sat = MIN( 0.0_wp, ( q_1d(k) - qr_1d(k) - qc_1d(k) ) / q_s - 1.0_wp )
-!
-!--          Actual temperature:
-             temp = t_l + l_d_cp * ( qc_1d(k) + qr_1d(k) )
-    
-             g_evap = 1.0_wp / ( ( l_v / ( r_v * temp ) - 1.0_wp ) * l_v /   &
-                      ( thermal_conductivity_l * temp ) + r_v * temp / &
-                      ( diff_coeff_l * e_s ) )
-!
-!--          Mean weight of rain drops
-             xr = hyrho(k) * qr_1d(k) / nr_1d(k)
-!
-!--          Weight averaged diameter of rain drops:
-             dr = ( xr * dpirho_l )**( 1.0_wp / 3.0_wp )
-!
-!--          Compute ventilation factor and intercept parameter 
-!--          (Seifert and Beheng, 2006; Seifert, 2008):
-             IF ( ventilation_effect )  THEN
-!
-!--             Shape parameter of gamma distribution (Milbrandt and Yau, 2005;
-!--             Stevens and Seifert, 2008):
-                mu_r = 10.0_wp * ( 1.0_wp + TANH( 1.2E3_wp * ( dr - 1.4E-3_wp ) ) )
-!
-!--             Slope parameter of gamma distribution (Seifert, 2008):
-                lambda_r = ( ( mu_r + 3.0_wp ) * ( mu_r + 2.0_wp ) *       &
-                             ( mu_r + 1.0_wp ) )**( 1.0_wp / 3.0_wp ) / dr
-
-                mu_r_2   = mu_r + 2.0_wp
-                mu_r_5d2 = mu_r + 2.5_wp 
-                f_vent = a_vent * gamm( mu_r_2 ) *                            &
-                         lambda_r**( -mu_r_2 ) +                              &
-                         b_vent * schmidt_p_1d3 *                             &
-                         SQRT( a_term / kin_vis_air ) * gamm( mu_r_5d2 ) *    &
-                         lambda_r**( -mu_r_5d2 ) *                            &
-                         ( 1.0_wp - 0.5_wp * ( b_term / a_term ) *            &
-                         ( lambda_r /                                         &
-                         (       c_term + lambda_r ) )**mu_r_5d2 -            &
-                                 0.125_wp * ( b_term / a_term )**2.0_wp *     &
-                         ( lambda_r /                                         &
-                         ( 2.0_wp * c_term + lambda_r ) )**mu_r_5d2 -         &
-                                 0.0625_wp * ( b_term / a_term )**3.0_wp *    &
-                         ( lambda_r /                                         &
-                         ( 3.0_wp * c_term + lambda_r ) )**mu_r_5d2 -         &
-                                 0.0390625_wp * ( b_term / a_term )**4.0_wp * &
-                         ( lambda_r /                                         &
-                         ( 4.0_wp * c_term + lambda_r ) )**mu_r_5d2 )
-                nr_0   = nr_1d(k) * lambda_r**( mu_r + 1.0_wp ) /             &
-                         gamm( mu_r + 1.0_wp ) 
-             ELSE
-                f_vent = 1.0_wp
-                nr_0   = nr_1d(k) * dr
-             ENDIF
-!
-!--          Evaporation rate of rain water content (Seifert and Beheng, 2006):
-             evap = 2.0_wp * pi * nr_0 * g_evap * f_vent * sat /    &
-                    hyrho(k)
-
-             evap    = MAX( evap, -qr_1d(k) / dt_micro )
-             evap_nr = MAX( c_evap * evap / xr * hyrho(k), &
-                            -nr_1d(k) / dt_micro )
-
-             qr_1d(k) = qr_1d(k) + evap * dt_micro
-             nr_1d(k) = nr_1d(k) + evap_nr * dt_micro
-          ENDIF          
-
+       CALL cpu_log( log_point_s(58), 'evaporation', 'start' )
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzb_s_inner(j,i)+1, nzt
+                IF ( qr(k,j,i) > eps_sb )  THEN
+!
+!--                Actual liquid water temperature:
+                   t_l = t_d_pt(k) * pt(k,j,i)
+!
+!--                Saturation vapor pressure at t_l:
+                   e_s = 610.78_wp * EXP( 17.269_wp * ( t_l - 273.16_wp ) /    &
+                                          ( t_l - 35.86_wp )                   &
+                                        )
+!
+!--                Computation of saturation humidity:
+                   q_s   = 0.622_wp * e_s / ( hyp(k) - 0.378_wp * e_s )
+                   alpha = 0.622_wp * l_d_r * l_d_cp / ( t_l * t_l )
+                   q_s   = q_s * ( 1.0_wp + alpha * q(k,j,i) ) /               &
+                           ( 1.0_wp + alpha * q_s )
+!
+!--                Supersaturation:
+                   sat   = ( q(k,j,i) - qr(k,j,i) - qc(k,j,i) ) / q_s - 1.0_wp
+!
+!--                Evaporation needs only to be calculated in subsaturated regions
+                   IF ( sat < 0.0_wp )  THEN
+!
+!--                   Actual temperature:
+                      temp = t_l + l_d_cp * ( qc(k,j,i) + qr(k,j,i) )
+             
+                      g_evap = 1.0_wp / ( ( l_v / ( r_v * temp ) - 1.0_wp ) *     &
+                                          l_v / ( thermal_conductivity_l * temp ) &
+                                          + r_v * temp / ( diff_coeff_l * e_s )   &
+                                        )
+!
+!--                   Mean weight of rain drops
+                      xr = hyrho(k) * qr(k,j,i) / nr(k,j,i)
+!
+!--                   Weight averaged diameter of rain drops:
+                      dr = ( xr * dpirho_l )**( 1.0_wp / 3.0_wp )
+!
+!--                   Compute ventilation factor and intercept parameter 
+!--                   (Seifert and Beheng, 2006; Seifert, 2008):
+                      IF ( ventilation_effect )  THEN
+!
+!--                      Shape parameter of gamma distribution (Milbrandt and Yau, 
+!--                      2005; Stevens and Seifert, 2008):
+                         mu_r = 10.0_wp * ( 1.0_wp + TANH( 1.2E3_wp *          &
+                                                          ( dr - 1.4E-3_wp ) ) )
+!
+!--                      Slope parameter of gamma distribution (Seifert, 2008):
+                         lambda_r = ( ( mu_r + 3.0_wp ) * ( mu_r + 2.0_wp ) *  &
+                                      ( mu_r + 1.0_wp )                        &
+                                    )**( 1.0_wp / 3.0_wp ) / dr
+
+                         mu_r_2   = mu_r + 2.0_wp
+                         mu_r_5d2 = mu_r + 2.5_wp 
+
+                         f_vent = a_vent * gamm( mu_r_2 ) *                     &
+                                  lambda_r**( -mu_r_2 ) + b_vent *              &
+                                  schmidt_p_1d3 * SQRT( a_term / kin_vis_air ) *&
+                                  gamm( mu_r_5d2 ) * lambda_r**( -mu_r_5d2 ) *  &
+                                  ( 1.0_wp -                                    &
+                                    0.5_wp * ( b_term / a_term ) *              &
+                                    ( lambda_r / ( c_term + lambda_r )          &
+                                    )**mu_r_5d2 -                               &
+                                    0.125_wp * ( b_term / a_term )**2 *         &
+                                    ( lambda_r / ( 2.0_wp * c_term + lambda_r ) &
+                                    )**mu_r_5d2 -                               &
+                                    0.0625_wp * ( b_term / a_term )**3 *        &
+                                    ( lambda_r / ( 3.0_wp * c_term + lambda_r ) &
+                                    )**mu_r_5d2 -                               &
+                                    0.0390625_wp * ( b_term / a_term )**4 *     & 
+                                    ( lambda_r / ( 4.0_wp * c_term + lambda_r ) &
+                                    )**mu_r_5d2                                 &
+                                  )
+
+                         nr_0   = nr(k,j,i) * lambda_r**( mu_r + 1.0_wp ) /    &
+                                  gamm( mu_r + 1.0_wp ) 
+                      ELSE
+                         f_vent = 1.0_wp
+                         nr_0   = nr(k,j,i) * dr
+                      ENDIF
+   !
+   !--                Evaporation rate of rain water content (Seifert and 
+   !--                Beheng, 2006):
+                      evap    = 2.0_wp * pi * nr_0 * g_evap * f_vent * sat /   &
+                                hyrho(k)
+                      evap    = MAX( evap, -qr(k,j,i) / dt_micro )
+                      evap_nr = MAX( c_evap * evap / xr * hyrho(k),            &
+                                     -nr(k,j,i) / dt_micro )
+
+                      qr(k,j,i) = qr(k,j,i) + evap    * dt_micro
+                      nr(k,j,i) = nr(k,j,i) + evap_nr * dt_micro
+
+                   ENDIF
+                ENDIF          
+
+             ENDDO
+          ENDDO
        ENDDO
 
-    END SUBROUTINE evaporation_rain_ij
-
-
-    SUBROUTINE sedimentation_cloud_ij( i, j )
+       CALL cpu_log( log_point_s(58), 'evaporation', 'stop' )
+
+    END SUBROUTINE evaporation_rain
+
+
+    SUBROUTINE sedimentation_cloud
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, dzu, nc_1d, pt_1d, q_1d, qc_1d
+           ONLY:  ddzu, dzu, pt, q, qc
 
        USE cloud_parameters,                                                   &
-           ONLY:  eps_sb, hyrho, k_st, l_d_cp, prr, pt_d_t, rho_l, sigma_gc
+           ONLY:  eps_sb, hyrho, l_d_cp, nc_const, pt_d_t, sed_qc_const
 
        USE constants,                                                          &
@@ -844,6 +698,9 @@
            ONLY:  dt_do2d_xy, dt_micro, intermediate_timestep_count
 
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
 
        USE kinds
@@ -855,43 +712,48 @@
        INTEGER(iwp) ::  k                 !:
 
-       REAL(wp)     ::  sed_qc_const      !:
-
-
-       REAL(wp), DIMENSION(nzb:nzt+1) :: sed_qc
-
-!
-!--    Sedimentation of cloud droplets (Heus et al., 2010):
-       sed_qc_const = k_st * ( 3.0_wp / ( 4.0_wp * pi * rho_l ))**( 2.0_wp / 3.0_wp ) *   &
-                     EXP( 5.0_wp * LOG( sigma_gc )**2 )
-
+       REAL(wp), DIMENSION(nzb:nzt+1) :: sed_qc !:
+
+       CALL cpu_log( log_point_s(59), 'sed_cloud', 'start' )
+
+!
+!--    Sedimentation of cloud droplets (Ackermann et al., 2009, MWR):
        sed_qc(nzt+1) = 0.0_wp
 
-       DO  k = nzt, nzb_s_inner(j,i)+1, -1
-          IF ( qc_1d(k) > eps_sb )  THEN
-             sed_qc(k) = sed_qc_const * nc_1d(k)**( -2.0_wp / 3.0_wp ) * &
-                        ( qc_1d(k) * hyrho(k) )**( 5.0_wp / 3.0_wp )
-          ELSE
-             sed_qc(k) = 0.0_wp
-          ENDIF
-
-          sed_qc(k) = MIN( sed_qc(k), hyrho(k) * dzu(k+1) * q_1d(k) /     &
-                                      dt_micro + sed_qc(k+1) )
-
-          q_1d(k)  = q_1d(k)  + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) /  &
-                                hyrho(k) * dt_micro
-          qc_1d(k) = qc_1d(k) + ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) / & 
-                                hyrho(k) * dt_micro
-          pt_1d(k) = pt_1d(k) - ( sed_qc(k+1) - sed_qc(k) ) * ddzu(k+1) / &
-                                hyrho(k) * l_d_cp * pt_d_t(k) * dt_micro
-
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             DO  k = nzt, nzb_s_inner(j,i)+1, -1
+
+                IF ( qc(k,j,i) > eps_sb )  THEN
+                   sed_qc(k) = sed_qc_const * nc_const**( -2.0_wp / 3.0_wp ) * &
+                               ( qc(k,j,i) * hyrho(k) )**( 5.0_wp / 3.0_wp )
+                ELSE
+                   sed_qc(k) = 0.0_wp
+                ENDIF
+
+                sed_qc(k) = MIN( sed_qc(k), hyrho(k) * dzu(k+1) * q(k,j,i) /   &
+                                            dt_micro + sed_qc(k+1)             &
+                               )
+
+                q(k,j,i)  = q(k,j,i)  + ( sed_qc(k+1) - sed_qc(k) ) *          &
+                                        ddzu(k+1) / hyrho(k) * dt_micro
+                qc(k,j,i) = qc(k,j,i) + ( sed_qc(k+1) - sed_qc(k) ) *          &
+                                        ddzu(k+1) / hyrho(k) * dt_micro
+                pt(k,j,i) = pt(k,j,i) - ( sed_qc(k+1) - sed_qc(k) ) *          &
+                                        ddzu(k+1) / hyrho(k) * l_d_cp *        &
+                                        pt_d_t(k) * dt_micro
+
+             ENDDO
+          ENDDO
        ENDDO
 
-    END SUBROUTINE sedimentation_cloud_ij
-
-
-    SUBROUTINE sedimentation_rain_ij( i, j )
+       CALL cpu_log( log_point_s(59), 'sed_cloud', 'stop' )
+
+    END SUBROUTINE sedimentation_cloud
+
+
+    SUBROUTINE sedimentation_rain
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, dzu, nr_1d, pt_1d, q_1d, qr_1d
+           ONLY:  ddzu, dzu, nr, pt, q, qr
 
        USE cloud_parameters,                                                   &
@@ -901,10 +763,14 @@
 
        USE control_parameters,                                                 &
-           ONLY:  dt_do2d_xy, dt_micro, dt_3d, intermediate_timestep_count,    &
+           ONLY:  call_microphysics_at_all_substeps, dt_do2d_xy, dt_micro,     &
+                  dt_3d, intermediate_timestep_count,                          &
                   intermediate_timestep_count_max,                             &
                   precipitation_amount_interval, time_do2d_xy
 
+       USE cpulog,                                                             &
+           ONLY:  cpu_log, log_point_s
+
        USE indices,                                                            &
-           ONLY:  nzb, nzb_s_inner, nzt
+           ONLY:  nxl, nxr, nys, nyn, nzb, nzb_s_inner, nzt
 
        USE kinds
